aboutsummaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorrudson <rudson@04377dda-e619-0410-9926-eae83683ac58>2009-06-07 12:49:52 +0000
committerrudson <rudson@04377dda-e619-0410-9926-eae83683ac58>2009-06-07 12:49:52 +0000
commit763e77bbe55fad4af62a5c2f27a6a2e83ac67405 (patch)
tree0f9ee8b08a765a16d3c85474863249acb12b3535
parent222d797e78fbbda8ab9815d58f941cddef425dcd (diff)
downloadsimplepkg-763e77bbe55fad4af62a5c2f27a6a2e83ac67405.tar.gz
simplepkg-763e77bbe55fad4af62a5c2f27a6a2e83ac67405.tar.bz2
git-svn-id: svn+slack://slack.fluxo.info/var/svn/simplepkg@808 04377dda-e619-0410-9926-eae83683ac58
-rw-r--r--trunk/conf/simplepkg.conf3
-rw-r--r--trunk/mkbuild/generic.mkSlackBuild2
-rw-r--r--trunk/mkbuild/kde4.mkSlackBuild2
-rw-r--r--trunk/mkbuild/python.mkSlackBuild524
-rw-r--r--trunk/src/createpkg98
-rwxr-xr-xtrunk/src/mkbuild54
6 files changed, 608 insertions, 75 deletions
diff --git a/trunk/conf/simplepkg.conf b/trunk/conf/simplepkg.conf
index 0c0fc73..d5fc1b7 100644
--- a/trunk/conf/simplepkg.conf
+++ b/trunk/conf/simplepkg.conf
@@ -106,6 +106,9 @@ MOVE_SLACK_REQUIRED="on"
# characters only and no spaces.
CREATEPKG_AUTHOR=""
+# Set this to override de default package compress to tgz, tbz, tlz, txz. The default is tgz
+MKBUILD_COMPRESS="tgz"
+
# Set this to get author information automatically when creating a new mkbuild
MKBUILD_AUTHOR=""
diff --git a/trunk/mkbuild/generic.mkSlackBuild b/trunk/mkbuild/generic.mkSlackBuild
index d2049e0..03bc726 100644
--- a/trunk/mkbuild/generic.mkSlackBuild
+++ b/trunk/mkbuild/generic.mkSlackBuild
@@ -516,7 +516,7 @@ fi
# Build the package
cd "$PKG"
mkdir -p $REPOS/$SLACKBUILD_PATH
-makepkg -l y -c n "$REPOS/$SLACKBUILD_PATH/$PKG_NAME-$PKG_VERSION-$ARCH-$BUILD.tgz" || exit $ERROR_MKPKG
+makepkg -l y -c n "$REPOS/$SLACKBUILD_PATH/$PKG_NAME-$PKG_VERSION-$ARCH-$BUILD.[[MKBUILD COMPRESS]]" || exit $ERROR_MKPKG
</build_package>
<clean_builds> off
diff --git a/trunk/mkbuild/kde4.mkSlackBuild b/trunk/mkbuild/kde4.mkSlackBuild
index 8253267..2003545 100644
--- a/trunk/mkbuild/kde4.mkSlackBuild
+++ b/trunk/mkbuild/kde4.mkSlackBuild
@@ -510,7 +510,7 @@ fi
# Build the package
cd "$PKG"
mkdir -p $REPOS/$SLACKBUILD_PATH
-makepkg -l y -c n "$REPOS/$SLACKBUILD_PATH/$PKG_NAME-$PKG_VERSION-$ARCH-$BUILD.tgz" || exit $ERROR_MKPKG
+makepkg -l y -c n "$REPOS/$SLACKBUILD_PATH/$PKG_NAME-$PKG_VERSION-$ARCH-$BUILD.[[MKBUILD COMPRESS]]" || exit $ERROR_MKPKG
</build_package>
<clean_builds> off
diff --git a/trunk/mkbuild/python.mkSlackBuild b/trunk/mkbuild/python.mkSlackBuild
new file mode 100644
index 0000000..144d6cc
--- /dev/null
+++ b/trunk/mkbuild/python.mkSlackBuild
@@ -0,0 +1,524 @@
+#################################################################
+## Generic template for SlackBuilds
+##
+## Version 0.9.9 - Luis ( luis at riseup d0t net)
+## Alves ( rudsonalves at yahoo d0t com d0t br )
+## Version $Rev: 805 $ - $Author: rhatto $
+#################################################################
+#!/bin/bash
+<head> off
+#
+# [[PROGRAM NAME]].SlackBuild is free software; you can redistribute
+# it and/or modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation; either version 2 of the License,
+# or any later version.
+#
+# [[PROGRAM NAME]].SlackBuild is distributed in the hope that it will
+# be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+# Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+#
+# slackbuild for [[PROGRAM NAME]], by [[SLACKBUILD AUTHOR]]
+# requires: [[REQUIRES]]
+# tested: [[PROGRAM NAME]]-[[VERSION]]
+# model: generic.mkSlackBuild $Rev: 805 $
+#
+</head>
+
+<slackbuildrc> off
+# Look for slackbuildrc
+if [ -f ~/.slackbuildrc ]; then
+ source ~/.slackbuildrc
+elif [ -f /etc/slackbuildrc ]; then
+ source /etc/slackbuildrc
+fi
+</slackbuildrc>
+
+<set_variables> off
+# Set variables
+CWD="$(pwd)"
+SRC_NAME="[[SOURCE NAME]]"
+PKG_NAME="[[PACKAGE NAME]]"
+ARCH=${ARCH:=[[ARCH]]}
+SRC_VERSION=${VERSION:=[[VERSION]]}
+PKG_VERSION="$(echo "$SRC_VERSION" | tr '[[:blank:]-]' '_')"
+BUILD=${BUILD:=[[BUILD NUMBER]][[SLACKBUILD AUTHOR INITIALS]]}
+SRC_DIR=${SRC_DIR:=$CWD}/$PKG_NAME
+TMP=${TMP:=/tmp}
+PKG=${PKG:=$TMP/package-$PKG_NAME}
+REPOS=${REPOS:=$TMP}
+SLACKBUILD_PATH=${SLACKBUILD_PATH:="[[SLACKBUILD PATH]]"}
+PREFIX=${PREFIX:=[[PREFIX]]}
+PKG_WORK="$TMP/$SRC_NAME"
+CONF_OPTIONS=${CONF_OPTIONS:="[[OTHER CONFIGURE ARGS]]"}
+NUMJOBS=${NUMJOBS:="[[NUMBER OF JOBS]]"}
+</set_variables>
+
+<slkflags> off
+# Set system libraries' path and optmization flags based on $ARCH
+LIBDIR="$PREFIX/lib"
+
+if [ "$ARCH" = "i386" ]; then
+ SLKCFLAGS="-O2 -march=i386 -mtune=i686"
+elif [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686"
+elif [ "$ARCH" = "s390" ]; then
+ SLKCFLAGS="-O2"
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIR="$PREFIX/lib64"
+ LDFLAGS="-L/lib64 -L/usr/lib64"
+fi
+</slkflags>
+
+<error_codes> off
+# Set error codes (used by createpkg)
+ERROR_WGET=31; ERROR_MAKE=32; ERROR_INSTALL=33
+ERROR_MD5=34; ERROR_CONF=35; ERROR_HELP=36
+ERROR_TAR=37; ERROR_MKPKG=38; ERROR_GPG=39
+ERROR_PATCH=40; ERROR_VCS=41; ERROR_MKDIR=42
+ERROR_MANIFEST=43;
+</error_codes>
+
+<start_structure> off
+# Clean up any leftovers of previous builds
+rm -rf "$PKG_WORK" 2> /dev/null
+rm -rf "$PKG" 2> /dev/null
+
+# Create directories if necessary
+mkdir -p "$SRC_DIR" || exit $ERROR_MKDIR
+mkdir -p "$PKG" || exit $ERROR_MKDIR
+mkdir -p "$REPOS" || exit $ERROR_MKDIR
+mkdir -p "$PKG_WORK" || exit $ERROR_MKDIR
+
+</start_structure>
+
+<create_build_user_and_group> off
+# Creating build user and group
+if ! grep -qe "^$PKG_NAME:" /etc/group; then
+ groupadd $PKG_NAME
+fi
+if ! grep -qe "^$PKG_NAME:" /etc/passwd; then
+ useradd $PKG_NAME -g $PKG_NAME
+fi
+</create_build_user_and_group>
+
+<download_source> off
+# Dowload source if necessary
+SRC="[[SOURCE NAME CONSTRUCTION STRING]]"
+URL="[[DOWNLOAD FOLDER URL]]/$SRC"
+
+if [ ! -s "$SRC_DIR/$SRC" ] || ! [[DECOMPRESSOR]] [[DECOMPRESSOR TEST FLAG]] "$SRC_DIR/$SRC" 2> /dev/null; then
+ wget "$URL" -O "$SRC_DIR/$SRC" || exit $ERROR_WGET
+fi
+</download_source>
+
+<svn_source> off
+# Get svn source code
+cd "$SRC_DIR"
+SND_DIR="`basename [[DOWNLOAD FOLDER URL]]`"
+
+if [ "`find "$SRC_DIR/" -name .svn`" != "" ] && [ -d "$SRC_DIR/$SND_DIR" ]; then
+ cd $SND_DIR
+ svn update || exit $ERROR_VCS
+else
+ svn checkout [[DOWNLOAD FOLDER URL]] $SND_DIR || exit $ERROR_VCS
+ cd $SND_DIR
+fi
+
+PKG_VERSION="`svn info | awk '/Last Changed Rev:/ { print $4 }'`_svn"
+
+# Copy svn source
+cd "$PKG_WORK"
+cp -a $SRC_DIR/* .
+PKG_SRC="$PWD/$SND_DIR"
+cd "$PKG_SRC"
+</svn_source>
+
+<git_source> off
+# Get git source code
+cd "$SRC_DIR"
+SND_DIR="$PKG_NAME.git"
+
+if [ "`find "$SRC_DIR/" -name *.git`" != "" ] && [ -d "$SRC_DIR/$SND_DIR" ]; then
+ cd $SND_DIR
+ git pull || exit $ERROR_VCS
+else
+ git clone [[DOWNLOAD FOLDER URL]] $SND_DIR || exit $ERROR_VCS
+ cd $SND_DIR
+fi
+
+PKG_VERSION="`git log | head -n 1 | awk '{ print $2 }'`_git"
+
+# Copy git source
+cd "$PKG_WORK"
+cp -a $SRC_DIR/* .
+PKG_SRC="$PWD/$SND_DIR"
+cd "$PKG_SRC"
+</git_source>
+
+<download_patches> off
+# Download patches
+if echo [[PATCH URLS]] | grep -q -v "PATCH URLS"; then
+ for patch_url in [[PATCH URLS]]; do
+ patch="`basename $patch_url`"
+ if [ ! -s "$SRC_DIR/$patch" ]; then
+ wget "$patch_url" -O "$SRC_DIR/$patch" || exit $ERROR_WGET
+ fi
+ done
+fi
+</download_patches>
+
+<md5sum_check> off
+# MD5 checksum
+MD5SUM_URL="[[MD5SUM CODE]]"
+
+if [ ${#MD5SUM_URL} -eq 32 ]; then
+ MD5SUM_SRC="$(md5sum "$SRC_DIR/$SRC" | cut -c-32 )"
+ [ "$MD5SUM_SRC" == "$MD5SUM_URL" ] || exit $ERROR_MD5
+
+# Download source's MD5 checksum if necessary and check it
+if [ ! -s "$SRC_DIR/$SRC.[[MD5SUM EXTENSION]]" ]; then
+ wget "$URL.[[MD5SUM EXTENSION]]" -O "$SRC_DIR/$SRC.[[MD5SUM EXTENSION]]" || exit $ERROR_WGET
+fi
+
+md5sum -c "$SRC_DIR/$SRC.[[MD5SUM EXTENSION]]" || exit $ERROR_MD5
+</md5sum_check>
+
+<gpg_signature_check> off
+# Import minimized signing key from
+if echo [[SIGNING KEY URL]] | grep -q -v "SIGNING KEY URL"; then
+ lynx -dump [[SIGNING KEY URL]] | gpg --import || exit $ERROR_GPG
+elif echo [[SIGNING KEY ID]] | grep -q -v "SIGNING KEY ID"; then
+ gpg --recv-keys [[SIGNING KEY ID]] || exit $ERROR_GPG
+else
+ gpg --import << EOKEY || exit $ERROR_GPG
+[[SIGNING KEY]]
+EOKEY
+fi
+
+# Download source's signature if necessary and check it
+if echo [[SIGNING URL]] | grep -q -v "SIGNING URL"; then
+ SIGNATURE="`basename [[SIGNING URL]]`"
+ if [ ! -s "$SRC_DIR/$SIGNATURE" ]; then
+ wget "[[SIGNING URL]]" -O "$SRC_DIR/$SIGNATURE" || exit $ERROR_WGET
+ fi
+else
+ if [ -s "$SRC_DIR/$SRC.sig" ]; then
+ SIGNATURE="$SRC.sig"
+ elif [ -s "$SRC_DIR/$SRC.asc" ]; then
+ SIGNATURE="$SRC.asc"
+ else
+ echo Trying to get signature file from $URL.sig...
+ if wget "$URL.sig" -O "$SRC_DIR/$SRC.sig"; then
+ SIGNATURE="$SRC.sig"
+ else
+ rm $SRC_DIR/$SRC.sig
+ echo Trying to get signature file from $URL.asc...
+ if wget "$URL.asc" -O "$SRC_DIR/$SRC.asc"; then
+ SIGNATURE="$SRC.asc"
+ else
+ rm $SRC_DIR/$SRC.asc
+ echo "Error getting source's signature file"
+ exit $ERROR_GPG
+ fi
+ fi
+ fi
+fi
+
+echo Checking $SRC_DIR/$SRC with gpg using $SRC_DIR/$SIGNATURE...
+gpg --verify "$SRC_DIR/$SIGNATURE" "$SRC_DIR/$SRC" || exit $ERROR_GPG
+echo Success.
+</gpg_signature_check>
+
+<manifest_check> off
+# Check Manifest file
+if [ -e "$CWD/Manifest" ]; then
+
+ # Manifest signature checking
+ if grep -q -- "-----BEGIN PGP SIGNED MESSAGE-----" $CWD/Manifest; then
+ echo "Checking Manifest signature..."
+ gpg --verify $CWD/Manifest
+ if [ "$?" != "0" ]; then
+ exit $ERROR_MANIFEST
+ fi
+ fi
+
+ MANIFEST_LINES="`grep -E -v "^(MKBUILD|SLACKBUILD)" $CWD/Manifest | wc -l`"
+
+ for ((MANIFEST_COUNT=1; MANIFEST_COUNT <= $MANIFEST_LINES; MANIFEST_COUNT++)); do
+
+ MANIFEST_LINE="`grep -E -v "^(MKBUILD|SLACKBUILD)" $CWD/Manifest | head -n $MANIFEST_COUNT | tail -n 1`"
+ MANIFEST_FILE="`echo $MANIFEST_LINE | awk '{ print $2 }'`"
+ MANIFEST_FILE_TYPE="`echo $MANIFEST_LINE | awk '{ print $1 }'`"
+
+ if [ -e "$SRC_DIR/$MANIFEST_FILE" ]; then
+ MANIFEST_FILE="$SRC_DIR/$MANIFEST_FILE"
+ else
+ MANIFEST_FILE="`find $CWD -name $MANIFEST_FILE`"
+ fi
+
+ if [ ! -e "$MANIFEST_FILE" ] || [ -d "$MANIFEST_FILE" ]; then
+ continue
+ fi
+
+ echo "Checking Manifest for $MANIFEST_FILE_TYPE $MANIFEST_FILE integrity..."
+
+ SIZE_SRC="`wc -c $MANIFEST_FILE | awk '{ print $1 }'`"
+ SIZE_MANIFEST="`echo $MANIFEST_LINE | awk '{ print $3 }'`"
+
+ # Check source code size
+ if [ "$SIZE_SRC" != "$SIZE_MANIFEST" ]; then
+ echo "SIZE Manifest: $SIZE_MANIFEST; SIZE $SRC: $SIZE_SRC"
+ exit $ERROR_MANIFEST
+ else
+ echo "Size match."
+ fi
+
+ # Check source code integrity
+ for ALGO in md5 rmd160 sha1 sha256 sha512; do
+ if [ $ALGO = "rmd160" ]; then
+ ALGO_SRC="`openssl rmd160 $MANIFEST_FILE | awk '{ print $2 }'`"
+ else
+ ALGO_SRC="`"$ALGO"sum $MANIFEST_FILE | awk '{ print $1 }'`"
+ fi
+ ALGO="`echo $ALGO | tr '[:lower:]' '[:upper:]'`"
+ ALGO_MANIFEST=$(echo $MANIFEST_LINE | sed "s/.* $ALGO //" | awk '{ print $1 }')
+ if [ "$ALGO_SRC" != "$ALGO_MANIFEST" ]; then
+ echo "$ALGO Manifest: $ALGO_MANIFEST; $ALGO $SRC: $ALGO_SRC"
+ exit $ERROR_MANIFEST
+ else
+ echo "$ALGO match."
+ fi
+ done
+
+ done
+
+else
+ exit $ERROR_MANIFEST
+fi
+</manifest_check>
+
+<untar_source> off
+# Untar
+cd "$PKG_WORK"
+[[UNPACKER]] [[UNPACKER FLAGS]] "$SRC_DIR/$SRC" || exit $ERROR_TAR
+PKG_SRC="$PWD/`ls -l | awk '/^d/ { print $NF }'`"
+cd "$PKG_SRC"
+</untar_source>
+
+<patch_source> off
+# Patch source
+patches="[[PATCH FILES]] [[PATCH URLS]]
+ $PKG_NAME.diff $PKG_NAME-$PKG_VERSION.diff
+ $PKG_NAME-$PKG_VERSION-$ARCH.diff $PKG_NAME-$ARCH.diff"
+for patch in $patches; do
+ patch="`basename $patch`"
+ if [ -f "$CWD/$patch" ]; then
+ patch -Np[[NUMBER OF PREFIX SLASHES TO STRIP]] < "$CWD/$patch" || exit $ERROR_PATCH
+ elif [ -f "$CWD/patches/$patch" ]; then
+ patch -Np[[NUMBER OF PREFIX SLASHES TO STRIP]] < "$CWD/patches/$patch" || exit $ERROR_PATCH
+ elif [ -f "$CWD/$patch.gz" ]; then
+ gzip -dc "$CWD/$patch.gz" | patch -Np[[NUMBER OF PREFIX SLASHES TO STRIP]] || exit $ERROR_PATCH
+ elif [ -f "$CWD/patches/$patch.gz" ]; then
+ gzip -dc "$CWD/patches/$patch.gz" | patch -Np[[NUMBER OF PREFIX SLASHES TO STRIP]] || exit $ERROR_PATCH
+ elif [ -f "$SRC_DIR/$patch" ]; then
+ if [ "`basename $patch .gz`" != "$patch" ]; then
+ gzip -dc $SRC_DIR/$patch | patch -Np[[NUMBER OF PREFIX SLASHES TO STRIP]] || exit $ERROR_PATCH
+ elif [ "`basename $patch .bz2`" != "$patch" ]; then
+ bzip2 -dc $SRC_DIR/$patch | patch -Np[[NUMBER OF PREFIX SLASHES TO STRIP]] || exit $ERROR_PATCH
+ else
+ patch -Np[[NUMBER OF PREFIX SLASHES TO STRIP]] < "$SRC_DIR/$patch" || exit $ERROR_PATCH
+ fi
+ fi
+done
+</patch_source>
+
+<files_permissions> off
+# Set permissions
+chown -R root:root .
+find . \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \;
+</files_permissions>
+
+<configure> off
+# Configure
+#python setup.py
+</configure>
+
+<make_package> off
+# Compile
+python setup.py build || exit $ERROR_MAKE
+</make_package>
+
+<install_package> off
+# Install
+python setup.py install --root=$PKG || exit $ERROR_INSTALL
+</install_package>
+
+<strip_binaries> off
+# Strip binaries
+( cd "$PKG"
+ find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | \
+ xargs strip --strip-unneeded 2> /dev/null
+ find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | \
+ xargs strip --strip-unneeded 2> /dev/null
+)
+</strip_binaries>
+
+<compress_manpages> off
+# Compress and link manpages
+if [ -d "$PKG/$PREFIX/man" ]; then
+ ( cd "$PKG/$PREFIX/man"
+ for manpagedir in $(find . -type d -name "man*") ; do
+ ( cd $manpagedir
+ for eachpage in $( find . -type l -maxdepth 1) ; do
+ ln -s $( readlink $eachpage ).gz $eachpage.gz
+ rm $eachpage
+ done
+ gzip -9 *.?
+ )
+ done
+ )
+fi
+</compress_manpages>
+
+<compress_info_files> off
+# Compress info files
+if [ -d "$PKG/$PREFIX/info" ]; then
+ ( cd "$PKG/$PREFIX/info"
+ rm -f dir
+ gzip -9 *
+ )
+fi
+</compress_info_files>
+
+<copy_init_scripts> off
+# Copy init scripts
+mkdir -p $PKG/etc/rc.d
+cp $CWD/rc.* $PKG/etc/rc.d/
+</copy_init_scripts>
+
+<copy_config_files> off
+# Copy config files
+mkdir -p $PKG/etc
+for conf in [[CONFIG FILES]]; do
+ mkdir -p $PKG/etc/`dirname $conf`
+ if [ -e "$CWD/conf/$conf" ]; then
+ cp -a $CWD/conf/$conf $PKG/etc/$conf
+ elif [ -e "$CWD/$conf" ]; then
+ cp -a $CWD/$conf $PKG/etc/$conf
+ elif [ -e "$conf" ]; then
+ cp -a $conf $PKG/etc/$conf
+ fi
+done
+</copy_config_files>
+
+<install_documentation> off
+# Install documentation
+DOCS="[[DOCUMENTATION FILES]]"
+mkdir -p "$PKG/usr/doc/$PKG_NAME-$PKG_VERSION" || exit $ERROR_MKDIR
+for doc in $DOCS; do
+ if [ -f "$doc" ]; then
+ cp -a $doc "$PKG/usr/doc/$PKG_NAME-$PKG_VERSION"
+ fi
+done
+</install_documentation>
+
+<slackdesc> off
+# Add package description (slack-desc)
+mkdir -p "$PKG/install" || exit $ERROR_MKDIR
+cat << EODESC > "$PKG/install/slack-desc"
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':'.
+
+ |-----handy-ruler----------------------------------------------------|
+[[SLACK-DESC]]
+EODESC
+</slackdesc>
+
+<move_config_files> off
+# Move config files to .new to avoid overwriting any system config
+for config_file in [[CONFIG FILES]]; do
+ mv $PKG/$config_file $PKG/$config_file.new
+done
+</move_config_files>
+
+<postinstall_script> off
+# Add a post-installation script (doinst.sh)
+mkdir -p "$PKG/install" || exit $ERROR_MKDIR
+cat << EOSCRIPT > "$PKG/install/doinst.sh"
+config() {
+ NEW="\$1"
+ OLD="\$(dirname \$NEW)/\$(basename \$NEW .new)"
+ OLD="\$(dirname \$NEW)/\$(basename \$OLD .sample)"
+ OLD="\$(dirname \$NEW)/\$(basename \$OLD .dist)"
+
+ # If there's no config file by that name, mv it over:
+ if [ ! -r \$OLD ]; then
+ mv \$NEW \$OLD
+ elif [ "\$(cat \$OLD | md5sum)" = "\$(cat \$NEW | md5sum)" ]; then
+ # toss the redundant copy
+ rm \$NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+}
+
+mkgroup() {
+ GROUP="\$1"
+ if ! grep -qe "^\$GROUP:" etc/group; then
+ echo Creating group \$GROUP...
+ chroot . /usr/sbin/groupadd \$GROUP
+ fi
+}
+
+mkuser() {
+ USER="\$1"
+ if [ ! -z "\$2" ]; then
+ GROUP="\$2"
+ else
+ GROUP="\$USER"
+ fi
+ if ! grep -qe "^\$USER:" etc/passwd; then
+ echo Creating user \$USER...
+ chroot . /usr/sbin/useradd \$USER -g \$GROUP
+ fi
+}
+
+[[REST OF DOINST.SH]]
+EOSCRIPT
+</postinstall_script>
+
+<slack_required> off
+# Copy slack-required
+mkdir -p "$PKG/install" || exit $ERROR_MKDIR
+if [ -f "$CWD/slack-required" ]; then
+ cp $CWD/slack-required $PKG/install
+fi
+</slack_required>
+
+<build_package> off
+# Build the package
+cd "$PKG"
+mkdir -p $REPOS/$SLACKBUILD_PATH
+makepkg -l y -c n "$REPOS/$SLACKBUILD_PATH/$PKG_NAME-$PKG_VERSION-$ARCH-$BUILD.[[MKBUILD COMPRESS]]" || exit $ERROR_MKPKG
+</build_package>
+
+<clean_builds> off
+# Delete source and build directories if requested
+if [ "$CLEANUP" == "yes" ] || [ "$1" = "--cleanup" ]; then
+ rm -rf "$PKG_WORK" "$PKG"
+fi
+</clean_builds>
diff --git a/trunk/src/createpkg b/trunk/src/createpkg
index 18e5aaf..579f2c8 100644
--- a/trunk/src/createpkg
+++ b/trunk/src/createpkg
@@ -296,11 +296,11 @@ function repository_checkout {
svn="$PACKAGES_SVN"
fi
- if valid_svn_repo $svn; then
+ if valid_svn_repo $svn; then
svn checkout $svn $PACKAGES_DIR
chown_svn $PACKAGES_DIR && chgrp_svn $PACKAGES_DIR
if [ "$svn" != "$PACKAGES_SVN" ]; then
- echo "Using svn repository different from the one pointed at $CONF."
+ echo "Using svn repository different from the one pointed at $CONF."
fi
else
echo "Invalid repository $repository, aborting."
@@ -611,52 +611,52 @@ function create_package {
# Synchronize repository
[ $SYNC -eq $yes ] && sync_svn_repo $SLACKBUILDS_DIR $SLACKBUILDS_SVN
-
+
# Update keyring
update_keyring $SLACKBUILDS_DIR/GPG-KEY
-
+
# Get SlackBuild script
BUILD_SCRIPT="`find_slackbuild $PACKAGE`"
-
+
# Check SlackBuild script found
if [ -z "$BUILD_SCRIPT" ]; then
handle_error $ERROR_CREATEPKG_SLACKBUILD_NOTFOUND $PACKAGE
fi
-
+
# Select one SlackBuild
if [ "`echo $BUILD_SCRIPT | wc -w`" -gt 1 ]; then
AUX="$PS3"
PS3="Choice: "
LIST=`echo $BUILD_SCRIPT | sed 's/ /\n/g' | sed -r 's/.*\/(.*)\.SlackBuild$/\1/'`" EXIT"
-
+
select PACKAGE in `echo $LIST`; do
break
done
-
+
if [ "$PACKAGE" = "EXIT" ]; then
eecho $error "error: no package selected"
return 1
fi
-
+
# Select only one SlackBuild in BUILD_SCRIPT
BUILD_SCRIPT=`echo $BUILD_SCRIPT | sed 's/ /\n/g' | grep "/$PACKAGE.SlackBuild"`
PS3="$AUX"
else
PACKAGE=`basename $BUILD_SCRIPT .SlackBuild`
fi
-
+
# Get dirname and script name from slackbuild
SCRIPT_BASE="`dirname $BUILD_SCRIPT`"
SCRIPT_NAME="`basename $BUILD_SCRIPT`"
eecho $messag "$BASENAME: found script $PACKAGE.SlackBuild, now checking for dependencies"
-
+
# Sets the package's slack-required
if [ -f "$SCRIPT_BASE/$PACKAGE.slack-required" ]; then
SLACK_REQUIRED="$SCRIPT_BASE/$PACKAGE.slack-required"
elif [ -f "$SCRIPT_BASE/slack-required" ]; then
SLACK_REQUIRED="$SCRIPT_BASE/slack-required"
fi
-
+
if [ ! -z "$SLACK_REQUIRED" -a $NO_DEPS -ne $on ]; then
# This routine checks for dependencies in package's slack-required
(
@@ -671,17 +671,17 @@ function create_package {
done
)
[ $? -ne 0 ] && handle_error $error $ERROR_CREATEPKG_DEPENDENCY
-
+
eecho $messag "$BASENAME: done checking for $PACKAGE dependencies"
else
eecho $messag "$BASENAME: no unmet dependencies for $PACKAGE"
fi
-
+
eecho $messag "$BASENAME: processing $SCRIPT_NAME"
-
+
# Change to script base directory
cd $SCRIPT_BASE
-
+
# Use fakeroot if needed and available
if [ "`whoami`" != "root" ]; then
FAKEROOT="`which fakeroot`"
@@ -718,7 +718,7 @@ function create_package {
return 1
fi
fi
-
+
# Run SlackBuild script
[ $DEBUG -eq $off ] && SHELL_FLAG="+x" || SHELL_FLAG="-x"
(
@@ -733,27 +733,27 @@ function create_package {
SLACKBUILD_PATH="/" \
INTERACT=no $FAKEROOT sh $SHELL_FLAG ./$SCRIPT_NAME
)
-
+
# Check if package was built
handle_error $? $PACKAGE
-
+
# Fix source folder user
if [ ! -z "$SOURCE_DIR_USER" ]; then
chown -R $SOURCE_DIR_USER $SOURCE_DIR
fi
-
+
# Fix source folder group
if [ ! -z "$SOURCE_DIR_GROUP" ]; then
chgrp -R $SOURCE_DIR_GROUP $SOURCE_DIR
fi
-
+
# Get package name, arch, version and build number
PKG_NAME="`ls -1 -c $PACKAGES_DIR/$PACKAGE-*-*-*.tgz | head -n 1 | xargs basename`"
PACKAGE_NAME="`package_name $PKG_NAME`"
PACKAGE_VERSION="`package_version $PKG_NAME`"
PACKAGE_ARCH="`package_arch $PKG_NAME`"
PACKAGE_BUILD="`package_build $PKG_NAME`"
-
+
# Update package author
if [ ! -z "$CREATEPKG_AUTHOR" ]; then
AUTHOR="`echo $PACKAGE_BUILD | sed -e 's/^[0-9]*//'`"
@@ -768,14 +768,14 @@ function create_package {
echo "New package name is $PKG_NAME."
fi
fi
-
+
# Sign package
if [ $SIGN_PACKAGES -eq $on ]; then
-
+
echo "Signing package..."
-
+
get_sign_user
-
+
if [ ! -z "$SIGN_PACKAGES_USER" ] && [ "`whoami`" != "$SIGN_PACKAGES_USER" ]; then
tmp_sign_folder="`mktemp -d $TMP/createpkg_sign.XXXXXX`"
chown $SIGN_PACKAGES_USER $tmp_sign_folder
@@ -788,9 +788,9 @@ function create_package {
cp $tmp_sign_folder/$PKG_NAME.asc $PACKAGES_DIR/$PKG_NAME.asc
rm -rf $tmp_sign_folder
fi
-
+
fi
-
+
# Select repository directory
if [ $MOVE_BIN_PACKAGE -eq $on ]; then
SUBFOLDER="$( echo ${SCRIPT_BASE#$SLACKBUILDS_DIR/} )"
@@ -799,24 +799,24 @@ function create_package {
SUBFOLDER="."
NEW_REPOS=$PACKAGES_DIR
fi
-
+
# Update information from remote repository
repository_update $PACKAGES_DIR
-
+
# Create the repository folders
create_repo_folder $PACKAGES_DIR
-
+
# Remove old packages from repository tree
remove_old_package_data $PACKAGES_DIR
-
+
# Move package to SlackBuilds-like tree
- if [ $MOVE_BIN_PACKAGE -eq $on ]; then
-
+ if [ $MOVE_BIN_PACKAGE -eq $on ]; then
+
mv $PACKAGES_DIR/$PKG_NAME $NEW_REPOS/
if [ -e "$PACKAGES_DIR/$PKG_NAME.asc" ]; then
mv $PACKAGES_DIR/$PKG_NAME.asc $NEW_REPOS/
fi
-
+
if svn_folder $NEW_REPOS; then
(
cd $NEW_REPOS
@@ -825,23 +825,23 @@ function create_package {
svn_add $PKG_NAME.asc
)
fi
-
+
# Move package's slack-required to binary repository
if [ $MOVE_SLACK_REQUIRED -eq $on ]; then
if [ ! -z "$SLACK_REQUIRED" ]; then
svn_copy $SLACK_REQUIRED $NEW_REPOS/$PACKAGE.slack-required
fi
fi
-
+
fi
-
+
# Update repository metadata
update_metadata $PACKAGES_DIR
-
+
# General cleanup
echo Cleaning up the repository...
svn_remove_empty_folders $PACKAGES_DIR
-
+
# Update noarch repository
if [ $PACKAGES_REPOS_NOARCH -eq $on ] && [ "`package_arch $PKG_NAME`" == "noarch" ]; then
repository_update $NOARCH_DIR
@@ -855,18 +855,18 @@ function create_package {
update_metadata $NOARCH_DIR
svn_remove_empty_folders $NOARCH_DIR
fi
-
+
# Install package
if [ "$INSTALL" -eq $on ]; then
upgradepkg --install-new $NEW_REPOS/$PKG_NAME
fi
-
+
echo "Package saved at $NEW_REPOS/$PKG_NAME"
-
+
if [ $PACKAGES_REPOS_NOARCH -eq $on ] && [ "`package_arch $PKG_NAME`" == "noarch" ]; then
echo "Aditional copy saved at $NOARCH_DIR/$SUBFOLDER/$PKG_NAME"
fi
-
+
return $EXIT_CODE
}
@@ -965,9 +965,13 @@ case $1 in
list_slackbuilds
else
LIST=`find_slackbuild $2`
- for i in $LIST; do
- echo $i | sed 's/.*\/\([^\/]\+\)\.[Ss]lack[Bb]uild$/ \1/'
- done
+ if [ -z $LIST ]; then
+ EXIT_CODE=1
+ else
+ for i in $LIST; do
+ echo $i #| sed 's/.*\/\([^\/]\+\)\.[Ss]lack[Bb]uild$/ \1/'
+ done
+ fi
fi
exit $EXIT_CODE
;;
diff --git a/trunk/src/mkbuild b/trunk/src/mkbuild
index b490d6e..9be4a16 100755
--- a/trunk/src/mkbuild
+++ b/trunk/src/mkbuild
@@ -102,6 +102,8 @@ ${red}DESCRIPTION${normal}
print debug information
${red}-e${normal}, ${red}--edit${normal}
edit a mkbuild
+ ${red}-um${normal}, ${red}--update-manifest${normal}
+ update manifest file
${red}-wc${normal}, ${red}--working-copy${normal}
create an unversioned mkbuild working copy
${red}--get-param-copy${normal}
@@ -450,6 +452,7 @@ function start_build {
edit_file "VERSION" "$VERSION" $1
edit_file "SOURCE NAME CONSTRUCTION STRING" "$CONST_STRING" $1
edit_file "EXTENSION" "$EXTENSION" $1
+ edit_file "MKBUILD COMPRESS" "$MKBUILD_COMPRESS" $1
edit_file "DOWNLOAD FOLDER URL" "$URL_BASE" $1
edit_file "OTHER CONFIGURE ARGS" "$OPTIONS" $1
edit_file "DOCUMENTATION FILES" "$DOCFILES" $1
@@ -470,6 +473,9 @@ function clear_files {
[ ! -z $AUX_TMP ] && rm $AUX_TMP 2>/dev/null
[ ! -z $SLACKBUILD_TEMP ] && rm $SLACKBUILD_TEMP 2>/dev/null
[ ! -z $DIFF_FILE ] && rm $DIFF_FILE 2>/dev/null
+ if [ "`ls $TMP/`" == "" ]; then
+ rm -rf $TMP
+ fi
chmod 755 *.SlackBuild 2>/dev/null
}
@@ -517,15 +523,6 @@ function activate_sections {
set_status $SECTION $STATUS $SLACKBUILD_TEMP
done
- #if [ $SVN_MOD -eq $on -o $URL == "" ]; then
- # LIST_OFF="download_source md5sum_download_and_check_0 md5sum_download_and_check_1 gpg_signature_check untar_source"
- # verbose -e "\nSubversion or empty URL changes:"
- # for i in $LIST_OFF; do
- # set_status $i "off" $SLACKBUILD_TEMP
- # done
- # [ $SVN_MOD -eq $on ] && set_status svn_source "on" $SLACKBUILD_TEMP
- #fi
-
}
function build_slackbuild {
@@ -539,9 +536,11 @@ function build_slackbuild {
sed -i '/^<.*$/ d' $SLACKBUILD_TEMP
# Remove clear lines
# isto pode ser feito com "cat -s SLACKBUILD_TEMP ..."
- sed -i ':i ; $! N; s/\n/Ø/ ; t i ; s/Ø\{3,\}/ØØ/g ; s/Ø/\n/g' $SLACKBUILD_TEMP
+ #sed -i ':i ; $! N; s/\n/Ø/ ; t i ; s/Ø\{3,\}/ØØ/g ; s/Ø/\n/g' $SLACKBUILD_TEMP
+ cat -s $SLACKBUILD_TEMP > $SLACKBUILD
# Remove from frist line do #!/... line
- sed '1,/^#\!/ {/^#\!/ b; d }' $SLACKBUILD_TEMP > $SLACKBUILD
+ #sed '1,/^#\!/ {/^#\!/ b; d }' $SLACKBUILD_TEMP > $SLACKBUILD
+ sed -i '1,/^#\!/ {/^#\!/ b; d }' $SLACKBUILD
}
@@ -672,7 +671,7 @@ function apply_mkpatch {
}
# ----------------------------------------------------------------
-# svn functions
+# svn functions
# ----------------------------------------------------------------
function submit_slackbuild {
@@ -756,7 +755,7 @@ function submit_mkbuild {
echo "Removing mkbuild found at old path $oldplace"
svn_del $oldplace
fi
- done
+ done
submit_cleanup
@@ -776,7 +775,7 @@ function submit_cleanup {
}
-function import_mkbuilds {
+function import_mkbuilds {
# import mkbuilds into a subversion repository
# usage: repository_import [repository]
@@ -787,7 +786,7 @@ function import_mkbuilds {
repository="file:////var/svn/mkbuilds"
fi
- repository_import $MKBUILDS_DIR $repository
+ repository_import $MKBUILDS_DIR $repository
}
@@ -802,7 +801,7 @@ function import_slackbuilds {
repository="file:////var/svn/slackbuilds"
fi
- repository_import $SLACKBUILDS_DIR $repository
+ repository_import $SLACKBUILDS_DIR $repository
}
@@ -829,7 +828,7 @@ function repository_status {
}
# ----------------------------------------------------------------
-# general functions
+# general functions
# ----------------------------------------------------------------
function validate_parameter {
@@ -876,7 +875,7 @@ function decompress_find {
function load_parameters {
# Load Createpkg parameters
- SOURCE_DIR="`eval_parameter SOURCE_DIR /var/simplepkg/sources`"
+ SOURCE_DIR="`eval_parameter SOURCE_DIR /var/simplepkg/sources`"
SLACKBUILDS_DIR="`eval_parameter SLACKBUILDS_DIR /var/simplepkg/slackbuilds`"
[ ! -d $SLACKBUILDS_DIR ] && mkdir -p $SLACKBUILDS_DIR
@@ -890,7 +889,9 @@ function load_parameters {
COLOR_MODE="`eval_parameter COLOR_MODE none`"
TMP="`eval_parameter TMP /tmp`"
+ [ ! -e $TMP ] && mkdir -p $TMP
+ MKBUILD_COMPRESS="`eval_parameter MKBUILD_COMPRESS tgz`"
MKBUILD_AUTHOR="`eval_parameter MKBUILD_AUTHOR`"
MKBUILD_AUTHOR_INITIALS="`eval_parameter MKBUILD_AUTHOR_INITIALS`"
@@ -907,7 +908,7 @@ function load_parameters {
GPG_AGENT_OPTION="--use-agent"
else
GPG_AGENT_OPTION=""
- fi
+ fi
# For use at common.sh functions
SIGN="$SIGN_MANIFESTS"
@@ -987,7 +988,7 @@ function file_metainfo {
if [ "$file_type" == "DIST" ] || [ "$file_type" == "PATCH" ]; then
echo "Please make sure that the following hashes are correct:"
grep -e "^$file_type $dist_name " $manifest_file
- fi
+ fi
}
@@ -1066,10 +1067,10 @@ function edit_manifest {
else
echo "Can't get $DIST_SRC_NAME."
fi
- fi
+ fi
else
# Add source code information if its not already there
- if ! grep -q -e "^DIST $DIST_SRC_NAME " $WORK/Manifest; then
+ if ! grep -q -e "^DIST $DIST_SRC_NAME " $WORK/Manifest; then
update_manifest_info $DIST_SRC_NAME dist
fi
fi
@@ -1092,7 +1093,7 @@ function edit_manifest {
for i in `find $WORK | grep -E -v '(SlackBuild|old|slack-required|.mkbuild$|.tmp$|Manifest$)\*{0,1}$' | \
grep -E -v '(.diff$|.diff.gz$|.diff.bz2$|.patch$|.patch.gz$|.patch.bz2$)\*{0,1}$' | \
grep -v "/\.svn"`; do
- # Avoid folders, dotfiles and DIST files
+ # Avoid folders, dotfiles and DIST files
if [ ! -d "$WORK/$i" ] && \
[ "`basename $i`" != "$DIST_SRC_NAME" ] && \
! echo "`basename $i`" | grep -q -e "^\."; then
@@ -1252,7 +1253,7 @@ function update_manifest {
# Get mkbuild values
get_mkbuild_values
-
+
# Update the Manifest
edit_manifest --update
@@ -1564,7 +1565,7 @@ function search_mkbuild {
fi
if [ ! -z "$MKBUILD_PATH" ]; then
- if echo $name | grep -q -e "\.mkbuild$"; then
+ if echo $name | grep -q -e "\.mkbuild$"; then
if [ -d "$MKBUILDS_DIR/$MKBUILD_PATH" ]; then
find $MKBUILDS_DIR/$MKBUILD_PATH -name $MKBUILD_NAME
else
@@ -1583,7 +1584,7 @@ function search_mkbuild {
find $MKBUILDS_DIR -name $MKBUILD_NAME
fi
fi
-
+
}
function set_mkbuild_name {
@@ -1822,6 +1823,7 @@ SLACKDESC_LEN=78
# Load error codes
error_codes
+# Show help if has no arguments
[ $# -eq 0 ] && mkbuild_use && exit 1
# Configure input parameters